%noincl
include def.asi
include except.asi
include fproto.asi

include ehead.asi

;********************************************************************
comment #
	 _memset, _memcpy, _memchr
#
extrn 	_memset:near
extrn 	_memcpy:near
extrn 	_memchr:near

public 	entry

@st_TEXT
entry:

	@assume
	int   3

	;stack top is FFFC
	;stack system frame is _st_sys

	;set stack 
	mov   ax, _st_sys
	mov   sp, ax

	;set local buf below SP, set BP after enter == _st_sys
	@local_size = (1024)
	enter (@local_size - 2), 0
	mov   bp, ax

	;set stack system frame fields
	;seg PSP 
	mov   ss: [_seg_PSP], ds
	;seg TGROUP 
	mov   ss: word ptr [_seg_TGROUP], seg TGROUP

	;********************
	int   3

	;set _memset params
	push  4
	push  0FF02h

	lea   ax, byte ptr [bp - @local_size + 4]
	push  ss
	push  ax

	;here may push 0:0 if no need return
	if 1
	lea   ax, byte ptr [bp - @local_size]
	push  ss
	push  ax

	else
	push  0
	push  0
	endif

	push  offset @@catch00
	call  _memset
	int   3

	;********************
	;set _memcpy params
	push  4

	lea   ax, byte ptr [bp - @local_size + 4]
	push  ss
	push  ax

	lea   ax, byte ptr [bp - @local_size + 4 + 4]
	push  ss
	push  ax

	lea   ax, byte ptr [bp - @local_size]
	push  ss
	push  ax

	push  offset @@catch00
	call  _memcpy
	int   3

	;********************
	;set _memchr params
	push  10
	push  0

	lea   ax, byte ptr [bp - @local_size + 4]
	push  ss
	push  ax

	lea   ax, byte ptr [bp - @local_size]
	push  ss
	push  ax

	push  offset @@catch00
	call  _memchr
	int   3
	
@@ex00:
	int   3

	mov   ax, 04c00h
	int   21h

@@catch00:
	int   3

	mov   ax, 04c01h
	int   21h

_throw_null:
	int   3

	mov   ax, 04cFFh
	int   21h

_test:
	mov   ax, offset TGROUP: _null_data_ptr

	mov   ax, offset TGROUP: _exc_stack
	mov   ax, offset TGROUP: _exc_base
	mov   ax, offset TGROUP: _exc_limit
	mov   ax, offset TGROUP: _exc_sp

_TEXT		ends

	end entry
