;
%noincl
include def.asi
include except.asi
include fproto.asi

;********************************************************************
comment #
	 memset      DS/ES
#
public _memset

;void *far	memset( void *far const dst, const char c, const unsigned n ) throw(); 
@st_TEXT

_memset		proc near

	arg		@h1: word, @h2: far ptr byte, @v1: far ptr byte, @v2: byte: 2, @v3: word = @vsz
	;returns	

	;@h1 reserved for _throw_ip
	_ret_ptr			equ @h2
	;_this      		equ @h3

	v_dst				equ @v1
	v_c					equ @v2
	v_n					equ @v3

	;_stack_size 		equ @h5
	@arg_size 			equ ( @vsz )

	;local	@a1: word = _lsz
	@local_size = ( 0 )

	@assume
	enter @local_size, 0

	;
	les   di, [v_dst]

	;if( !dst )throw;
	or    di, di
	jz    @@throw00
	mov   ax, es
	;     : test  ax, 0FFFCh
	or    ax, ax
	jnz   @@else00

@@throw00:
	@throw_on_return
	jmp   @@ex00

@@else00:
	lds   bx, [_ret_ptr]

	;if( !ret )skip;
	or    bx, bx
	jz    @@skip01
	mov   ax, ds
	or    ax, ax
	jz    @@skip01

@@else01:
	mov   word ptr [bx], di
	mov   word ptr [bx+2], es

@@skip01:
	;
	mov   cx, [v_n]
	jcxz  @@ex00

	;assume we use opcode that tells for cpu to make a kind of "memory coalescing"
	mov   al, byte ptr [v_c]
	cld
	rep   stosb

@@ex00:
	leave
	ret   @arg_size

_memset		endp
_TEXT		ends

	end
